<?php defined('SYSPATH') OR die('No direct access allowed.');
/**
 * Base path of the web site. If this includes a domain, eg: localhost/kohana/
 * then a full URL will be used, eg: http://localhost/kohana/. If it only includes
 * the path, and a site_protocol is specified, the domain will be auto-detected.
 */
$config['site_domain'] = '/';

/**
 * Force a default protocol to be used by the site. If no site_protocol is
 * specified, then the current protocol is used, or when possible, only an
 * absolute path (with no protocol/domain) is used.
 */
//$config['site_protocol'] = 'http';
$config['site_protocol'] = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 'https' : 'http';
/**
 * Name of the front controller for this application. Default: index.php
 *
 * This can be removed by using URL rewriting.
 */
$config['index_page'] = '';

/**
 * Fake file extension that will be added to all generated URLs. Example: .html
 */
$config['url_suffix'] = '';

/**
 * Length of time of the internal cache in seconds. 0 or FALSE means no caching.
 * The internal cache stores file paths and config entries across requests and
 * can give significant speed improvements at the expense of delayed updating.
 */
$config['internal_cache'] = FALSE;

/**
 * Internal cache directory.
 */
$config['internal_cache_path'] = APPPATH.'cache/';

/**
 * Enable internal cache encryption - speed/processing loss
 * is neglible when this is turned on. Can be turned off
 * if application directory is not in the webroot.
 */
$config['internal_cache_encrypt'] = FALSE;

/**
 * Encryption key for the internal cache, only used
 * if internal_cache_encrypt is TRUE.
 *
 * Make sure you specify your own key here!
 *
 * The cache is deleted when/if the key changes.
 */
$config['internal_cache_key'] = 'foobar-changeme';

/**
 * Enable or disable gzip output compression. This can dramatically decrease
 * server bandwidth usage, at the cost of slightly higher CPU usage. Set to
 * the compression level (1-9) that you want to use, or FALSE to disable.
 *
 * Do not enable this option if you are using output compression in php.ini!
 */
$config['output_compression'] = FALSE;

/**
 * Enable or disable global XSS filtering of GET, POST, and SERVER data. This
 * option also accepts a string to specify a specific XSS filtering tool.
 */
$config['global_xss_filtering'] = TRUE;

/**
 * Enable or disable hooks.
 */
$config['enable_hooks'] = FALSE;

/**
 * Log thresholds:
 *  0 - Disable logging
 *  1 - Errors and exceptions
 *  2 - Warnings
 *  3 - Notices
 *  4 - Debugging
 */
$config['log_threshold'] = 4;

/**
 * Message logging directory.
 */
$config['log_directory'] = APPPATH.'logs';

/**
 * Enable or disable displaying of Kohana error pages. This will not affect
 * logging. Turning this off will disable ALL error pages.
 */
$config['display_errors'] = TRUE;

/**
 * Enable or disable statistics in the final output. Stats are replaced via
 * specific strings, such as {execution_time}.
 *
 * @see http://docs.kohanaphp.com/general/configuration
 */
$config['render_stats'] = TRUE;

/**
 * Filename prefixed used to determine extensions. For example, an
 * extension to the Controller class would be named MY_Controller.php.
 */
$config['extension_prefix'] = 'MY_';

/**
 * Additional resource paths, or "modules". Each path can either be absolute
 * or relative to the docroot. Modules can include any resource that can exist
 * in your application directory, configuration files, controllers, views, etc.
 */
$config['modules'] = array
(
	// MODPATH.'auth',      // Authentication
	// MODPATH.'kodoc',     // Self-generating documentation
	// MODPATH.'gmaps',     // Google Maps integration
	// MODPATH.'archive',   // Archive utility
	// MODPATH.'payment',   // Online payments
	// MODPATH.'unit_test', // Unit testing
	MODPATH.'mauth',		// Модуль автоизиции на файлах
	MODPATH.'ldap',         // Модуль соединения c LDAP сервером
	MODPATH.'ldapmisc',     // Модуль соединения c LDAP сервером
//	MODPATH.'user',			// Модуль управление пользователями
	MODPATH.'mmail',		// Модуль управления почтой
	MODPATH.'squid',		// Модуль управления прокси сервером
	MODPATH.'net',			// Модуль управления сетевыми интерфейсами
//	MODPATH.'qwe',			// Несуществующий модуль
	MODPATH.'term',         // Модуль управления Терминальным сервером
	MODPATH.'samba',        // Модуль управления Самбой
	MODPATH.'dhcp',			// Модуль управления DHCP
	MODPATH.'dns',			// Модуль управления DNS
	MODPATH.'firewall',     // Модуль управления Межсетевым экраном
	MODPATH.'ntpdate',      // Модуль управления датой и временем
	MODPATH.'powerman',     // Модуль управления питанием
	MODPATH.'filesystem',   // Модуль для работы с файловой системой
	MODPATH.'route',        // Модуль для работы с таблицей маршрутизации
	MODPATH.'traceroute',   // Модуль тестирования удаленных узлов
	MODPATH.'openvpn',      // Модуль управления VPN
	MODPATH.'backupds',     // Модуль бэкапа дс сервера
	MODPATH.'wizard',       // Модуль конфигуратора сети
	MODPATH.'replication',  // Модуль репликации с AD
	MODPATH.'cron',		// Модуль крона
	MODPATH.'wbaconf',      // Модуль настройки вебадминки
);


/**
 * Templates configuration
 * Конфигурация шаблона. Ничего особого просто название шаблона который сейчас используется
 */
 $config['template'] = 'idreams2';

if ( ! empty($_GET['template']) )
{
  $config['template'] = preg_replace("/[^a-z0-9]/ui", '', $_GET['template']);
}
 
